/* =====================================================================

   LiMo - Liblary
      Sync Main System.  - ᥤ롼

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

/* -------------------------------------------------------------
 --- History

  Oct.23.1999  Programing start (sprite sample)

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Preface

  RRMainInit       -- ᥤץʤ
  RRMain           -- ֤˥뤵ᥤ

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Include
-------------------------------------------------------------- */

#include <stdio.h>
#include <time.h>
#include <gtk/gtk.h>
#include <gdk_imlib.h>
#include  "rr_main.h"
#include  "rr_screen.h"

#include  "ball.xpm"

/* -------------------------------------------------------------
 --- Ƽ
-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- ѿ
-------------------------------------------------------------- */

/*--- local timer */
gint timer, lap;
time_t segment;

/* --- ǥץ쥤ݻ */
gint  fw, fh;

/* --- ¸ѥץ饤ȥե졼Хåե */
GdkPixmap  *smap;
GdkBitmap  *smask;
RRSprite   obj;

/* --- ¸ */
gboolean   trans;
gint       ball_max;
gint       int_handle;


/* -----------------------------------------------------------------------
 --- ץ
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  RRMainInit       -- ᥤץʤ

   return : void
   void

-------------------------------------------------------------- */
void RRMainInit(void)
{
  timer = 0;
  lap = 0;
  trans = TRUE;
  ball_max = 10;
  int_handle = 0;
  segment = time(NULL);
  RRScreenFontSetInit("-adobe-times-bold-r-normal-*-26-*-*-*-*-*-*-*,\
            -misc-fixed-medium-*-normal-*-24-*-*-*-*-*-jisx0208.1983-0");

  /* -- ߳ */
  interval_set(5);

  /* -- եå pixmap  */
  smap = gdk_pixmap_create_from_xpm_d(RRScreenWindow()->window,
				      &smask,
				      NULL,
				      ball_xpm);

}


/* -------------------------------------------------------------
  RRMainFree       -- ᥤץཪλ

   return : void
   void

-------------------------------------------------------------- */
void RRMainFree(void)
{
  if (smap != NULL) gdk_pixmap_unref(smap);
  if (smask != NULL) gdk_bitmap_unref(smask);
}


/* -------------------------------------------------------------
  RRMainWindowSize   -- եå

   return : void
   void
-------------------------------------------------------------- */
void       RRMainWindowSize(gint w, gint h)
{
  fw = w;
  fh = h;
}


/* -------------------------------------------------------------
  RRMain           -- ֤˥뤵ᥤ

   return : void
   void
-------------------------------------------------------------- */
gint RRMain(gpointer gdata)
{
  GtkStatusbar *stat;
  gchar tmp[128], info[128];
  gint  o1, o2, i;

  timer++;
  lap++;
  if (segment != time(NULL)) {
    segment = time(NULL);
    /* --- StatusBar ˾ɽ */
    stat = GTK_STATUSBAR(RRGetParts(RRGetParts(RRScreenWindow(), "vbox1"), "statusbar1"));
    sprintf(info, "frame %d/Sec.", lap);
    gtk_statusbar_push(stat, gtk_statusbar_get_context_id(stat, tmp), info);
    lap = 0;
  }

  /* --- Graphic Buffer Υå */
  RRScreenSwitch();

  /* --- ե졼 */
  i = timer % 31;
  if (i > 15) i = 15 - i;
  RRScreenClear(0, 0, 0x6000);

  for(i=0; i<ball_max; i++) {
    o1 = i* 273;
    o2 = i * 111;
    obj.sw = TRUE;
    obj.objmap = smap;
    if (trans == TRUE) {
      obj.objmask = smask;
    }
    else {
      obj.objmask = NULL;
    }
    obj.x = ((timer + o1) % 640);
    obj.y = ((timer + o2) % 480);
    if (obj.x > 320) obj.x = 640 - obj.x;
    if (obj.y > 240) obj.y = 480 - obj.y;
    obj.x *= 2;
    obj.y *= 2;
    obj.w = obj.h = 32;
    obj.ox = (i % 2) * 32;
    obj.oy = ((i % 4) / 2) * 32;
    obj.offset_x = obj.offset_y = 15;
    RRScreenObjPut(&obj);
  }

  return 1;
}



/* -------------------------------------------------------------
    --- ˥塼μ
-------------------------------------------------------------- */
void RRMainTransparent(gboolean sw)
{
  trans = sw;
}
void RRMainBall(gint n)
{
  ball_max = n;
}

void interval_set(gint n)
{
  if (int_handle != 0) gtk_timeout_remove(int_handle);
  int_handle = gtk_timeout_add(1000/n, (GtkFunction)RRMain, NULL);
}


